/* init_stuff.c */

#include "kb_wmouse.h"

/* init_controller() */
status_t init_controller(void)
{
  int tries;
  status_t read_failed, err;
  uint8 result;
//  edi = 0;
  
  
  for(tries = 0; tries >= 0; --tries) {
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    	while(read_failed == B_OK) {
      		dprintf(FLUSHED_MSG, isa->read_io_8(PS2_DATA_REG));
      		read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    	}
  
    err = controller_command(0xAA); //Destiny: means Reset Keyboard
    /* Destiny: Removed unnecessary inbetweener code
    if(err != B_OK) {
      dprintf(KB_CNTRL_TEST_FAILED);
      continue;
    }
     EOF DFIX */
     
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    if(read_failed != B_OK) {
      dprintf(GET_DATA_OBUF_EMPTY);
      continue;
    } else {
      result = isa->read_io_8(PS2_DATA_REG);
    }
  
    if(result == 0x55) break; 
    //Destiny: Controller Side Self-Test Result should be 0x55
    /* not OK */
    dprintf(KB_CNTRL_TEST_FAILED_2X, result);
  
  }

/* Destiny Inbetweener Code Begin*/

	err = controller_command (0xAB); // Keyboard interface test
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);

    /*  Destiny: need bracket to fix this!
    if(read_failed != B_OK) {
      dprintf(GET_DATA_OBUF_EMPTY);
      continue;
    } else {
      result = isa->read_io_8(PS2_DATA_REG);
    }
  
    //if(result > 0x00) break; 
    //Destiny: Keboard Interface-Test Result should be 0x00 from PS2_DATA_REG
    /* not OK */
    //dprintf(KB_CNTRL_TEST_FAILED_2X, result);
//*/	 
	err = controller_command (0xAE); //KB. I/F enable
	err = controller_command (0xA8); //Mouse I/F enable
	
	//Keyboard Side: Commands now to Keyboard and NOT controller!
	//reset kb. and self test
	err = keyboard_command (0xFF);
    //wait
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    //Keyboard should return ACK (0xFA) Implemented later on...
    //Now enable the KB.
	err = keyboard_command (0xF4);
	//wait
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    //we should now be done	with the KB.
	
/* END OF DESTINY INBETWEENER CODE */

/* FIX BY DESTINY: ALREADY IN INBETWEENER CODE 
  for(tries = 2; tries >= 0; --tries) {
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    while(read_failed == B_OK) {
      dprintf(FLUSHED_MSG, isa->read_io_8(PS2_DATA_REG));
      read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
      if(read_failed == B_OK);
    }
    err = controller_command(0xAE);
    if(err == B_OK) break;
    dprintf(ERROR_ENABLING_KB);
  }


  for(tries = 2; tries >= 0; --tries) {
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    while(read_failed == B_OK) {
      dprintf(FLUSHED_MSG, isa->read_io_8(PS2_DATA_REG));
      read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    }
    err = controller_command(0xAE);
    if(err == B_OK) break;
    dprintf(ERROR_ENABLING_KB);
  }


  for(tries = 2; tries >= 0; --tries) {
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    while(read_failed == B_OK) {
      dprintf(FLUSHED_MSG, isa->read_io_8(PS2_DATA_REG));
      read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    }
    err = controller_command(0xA8);
    if(err == B_OK) break;
    dprintf(ERROR_ENABLING_MOUSE);
  }
*/  
  //return err;
  /* DESTINY FIX HERE TO ENSURE THAT OUR CODE IS ACCEPTED */
  return B_OK;
}

/* init_keyboard() */
status_t init_keyboard(void)
{
  /*DESTINY: code implemented upstairs 
  int tries;
  status_t read_failed, err;
  
  for(tries = 15; tries >= 0; --tries) {
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    while(read_failed == B_OK) {
      dprintf(FLUSHED_MSG, isa->read_io_8(PS2_DATA_REG));
      read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    }
    err = keyboard_command(0xF5);
    if (err == B_OK) {
      found_keyboard = 1;
      return B_OK;
    }
    dprintf(RESP_KB_DIS_NOT_ACK);
  }
  */
  //HAVE OF COURSE TO REMOVE BELOW IF REENABLE CODE ABOVE
  found_keyboard = 1;
  return B_OK;
}

/* disable_ps2_mouse() */
status_t disable_ps2_mouse(void)
{
  int tries;
  uint8 result;
  status_t read_failed, write_failed, err;
    
  read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
  while(read_failed == B_OK) {
    dprintf(FLUSHED_MSG, isa->read_io_8(PS2_DATA_REG));
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
  }
  
  for(tries = 2; tries >= 0; --tries) {
    err = controller_command(0xD4);
    if(err == B_OK) {
      write_failed = wait_status(PS2_STATUS_REG, PS2_IBUF_FULL, 0);
      if(write_failed != B_OK) {
        dprintf(PUT_DATA_IBUF_FULL);
      } else {
        isa->write_io_8(PS2_DATA_REG, 0xF5);
      }
    }
  
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    if(read_failed != B_OK) {
      dprintf(GET_DATA_OBUF_EMPTY);
    } else {
      result = isa->read_io_8(PS2_DATA_REG);
      if(result == 0xFA) return B_OK;
    }
    dprintf(RESP_MOUSE_DIS_NOT_ACK, result);
  
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    while(read_failed == B_OK) {
      dprintf(FLUSHED_MSG, isa->read_io_8(PS2_DATA_REG));
      read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    }
  }  
}

/* init_serial_mouse() */
status_t init_serial_mouse(void)
{
  struct termios our_termios;
  char dirent_name_full[B_PATH_NAME_LENGTH + 1];
  DIR *ports_dirhandle;
  char *some_string, *serName;
  struct dirent *ports_dirent;
  int fd;
  int rts_state;
  char read_byte;
  int tries;
  int bytes_read;
  bool continue_please;
/*  our_termios_ptr = &our_termios;*/
  
  some_string = serName = dirent_name_full;
  ports_dirhandle = opendir("/dev/ports");
  while(1) {
    ports_dirent = readdir(ports_dirhandle);
    if(!ports_dirent) {
      closedir(ports_dirhandle);
      if(ser_fd_count > 0) return B_OK;
      else return B_ERROR;
    }
    strcpy(dirent_name_full, "/dev/ports");
    memset(&(dirent_name_full[12]), 0, 1013);
  
    // if no difference  eax = 0;
    // if var_450 > dot_string  eax = 1;
    // if var_450 < dot_string  eax = -1;
    if(strncmp(".", ports_dirent->d_name, 2) == 0) continue;
    if(strncmp("..", ports_dirent->d_name, 3) == 0) continue;
  
    strcpy(&some_string[strlen(some_string)], ports_dirent->d_name);
    dprintf(KB_WMOUSE_OPENING, some_string);
    fd = open(some_string, O_EXCL | O_NONBLOCK);  /* exclusive creat, non-blocking I/O */
    if(fd < 0) {
      dprintf(KB_WMOUSE_BUSY, some_string);
      continue;
    }
  
    fcntl(fd, F_SETFL, fcntl(fd, F_GETFL) & 0x7F);
    ioctl(fd, TCGETA, &our_termios);
    our_termios.c_cflag = (our_termios.c_cflag & 0xC0) | 0x809;  /* var_43C */
    our_termios.c_cc[4] = our_termios.c_cc[5] = 0;
    ioctl(fd, TCSETA, &our_termios);
    snooze(10000LL);  /* 10 ms */
    rts_state = 0;
    ioctl(fd, TCSETRTS, &rts_state);
    snooze(200000LL);  /* 200 ms */
    rts_state = 1;
    ioctl(fd, TCSETRTS, &rts_state);
  
    for(tries = 0; tries < 20; ++tries) {
      bytes_read = read(fd, &read_byte, 0x20);
      if(bytes_read > 4) break;
      if(!(bytes_read < 0) && read_byte == 'M') {
        snooze(40000LL);
        ioctl(fd, TCFLSH, 2);
        dprintf(KB_WMOUSE_SERIAL_MOUSE_ON, serName);
        ++ser_fd_count;
        ser_fd_list = (int32 *)realloc(ser_fd_list, 1 + ser_fd_count * (sizeof(typeof(ser_fd_list))));
        ser_fd_list[ser_fd_count-1] = fd;
        our_termios.c_cc[4] = 3;
        our_termios.c_cc[5] = 50;  // 0x32
        ioctl(fd, TCSETA, &our_termios);
        continue_please = true;
        break;
      }
      snooze(50000LL);
    }  /* for */
    if(continue_please) continue;
    dprintf(KB_MOUSE_NO_MOUSE_AT, serName);
    close(fd);
  }  /* while(1) */
}  /* init_serial_mouse */

/* enable_ps2_mouse() */
void enable_ps2_mouse(void) {
  int tries;
  uint8 result;
  status_t write_failed, read_failed, err;
  
  
  for(tries = 2; tries >= 0; --tries) {
    err = controller_command(0xD4);
    if(err == B_OK) {
      write_failed = wait_status(PS2_STATUS_REG, PS2_IBUF_FULL, 0);
      if(write_failed != B_OK) {
        dprintf(PUT_DATA_IBUF_FULL);
      } else {
        isa->write_io_8(PS2_DATA_REG, 0xF4);  /* AUX_ENABLE_DEV */
      }
    }
  
    read_failed = wait_status(PS2_STATUS_REG, PS2_OBUF_FULL, PS2_OBUF_FULL);
    if(read_failed != B_OK) {
      dprintf(GET_DATA_OBUF_EMPTY);
      continue;
    } else {
      result = isa->read_io_8(PS2_DATA_REG);
    }
  
    if(result == 0xFE) continue;
    if(result == 0xFA) {
      dprintf(PS2_SUCC_ENABLE_MOUSE);
      return;
    } else {
      dprintf(PS2_BAD_ENABLE_RESPONSE, result);
      continue;
    }
  }  /* for(tries) */
}  /* enable_ps2_mouse() */
