/* wait_status.c */

#include "kb_wmouse.h"

/* wait_status()                             */
/* port: 0x60 or 0x64                        */
/* condition: IBF or OBF                     */
/* success: IBF or OBF (as appropriate) or 0 */
inline status_t wait_status(int32 port, int8 condition, int8 success) {
  int tries = 100;

  while (tries != 0) {
    if((isa->read_io_8(port) & condition) == success) break;
    spin(100LL);
    --tries;
  }

  if(tries == 0) {
    dprintf("kb_mouse: wait_status timed out after 10 ms\n");
    return B_ERROR;
  }

  return B_OK;
}  /* wait_status() */
